# SPDX-FileCopyrightText: 2020 Mintlab B.V.
#
# SPDX-License-Identifier: EUPL-1.2

image: python:3.8-slim-buster

stages:
  - qa
  - release

REUSE Compliance:
  # Run for merge requests, tags and merge to default branch
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  stage: qa
  image:
    name: fsfe/reuse:latest
    entrypoint: [""]
  script:
    - reuse lint

QA:
  # Run for merge requests, tags and merge to default branch
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

  coverage: "/TOTAL.+ ([0-9]{1,3}%)/"
  artifacts:
    name: $CI_BUILD_REF_NAME
    expire_in: 12 mos
    reports:
      junit: junit.xml
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

  script:
    - apt-get update
    - apt-get install -y libmagic1
    - pip install -r requirements/base.txt
    - pip install -r requirements/test.txt
    - bin/git-hooks/pre-commit -c -j junit.xml
  stage: qa

Publish to PyPi:
  stage: release
  # Run only when a new tag is made
  rules:
    - if: $CI_COMMIT_TAG
  script:
    - echo "Distributing package to pypi.org"
    - pip3 install twine wheel
    - python3 setup.py sdist bdist_wheel
    - twine upload dist/*
